- name: Test oci proxy cache
  block:
    - name: Check test configuration
      ansible.builtin.assert:
        that:
          - nexus_oci_proxy_cache_engine in ["docker"]

    - name: Pull OCI image from docker-all group
      ansible.builtin.command: |
        docker exec nexus-testing-2 sh -c "docker pull {{ nexus_oci_test_image }}"
      register: pull_oci
      changed_when: "'Pull complete' in pull_oci.stdout"

    - name: Check if test repo is not empty
      ansible.builtin.uri:
        url: "{{ nexus_url }}/service/rest/v1/search?repository=docker-test-proxy"
        method: GET
        force: true
        return_content: true
        status_code: [200]
      register: package_info
      retries: 2
      delay: 4
      until: package_info.json['items'] | length > 0
      failed_when: (package_info.json['items'] | length) == 0

    - name: Check if docker image is cached
      ansible.builtin.debug:
        msg: "hello-world is cached at {{ item.assets[0].downloadUrl }}"
      loop: "{{ package_info.json['items'] | selectattr('name', 'search', 'hello-world') | list }}"
      loop_control:
        label: "{{ item.name }}"
